# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify Alma, CentOS, CentOS Stream and Rocky Linux as rhel
%if "%{__distinit}" == "a" || "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "cs" || "%{__distinit}" == "rl"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

Name:		perl-SUPER
Version:	1.20190531
Release:	14.%{__distinit}%{__distvers}
Summary:	Sane superclass method dispatcher
License:	GPL-1.0-or-later OR Artistic-1.0-Perl
URL:		https://metacpan.org/release/SUPER
Source0:	https://cpan.metacpan.org/authors/id/C/CH/CHROMATIC/SUPER-%{version}.tar.gz
BuildArch:	noarch
# =============== Module Build =================
BuildRequires:	coreutils
BuildRequires:	findutils
BuildRequires:	make
BuildRequires:	perl-generators
BuildRequires:	perl-interpreter
BuildRequires:	perl(ExtUtils::MakeMaker)
# =============== Module Runtime ===============
BuildRequires:	perl(Carp)
BuildRequires:	perl(Scalar::Util) >= 1.20
BuildRequires:	perl(strict)
BuildRequires:	perl(Sub::Identify) >= 0.03
BuildRequires:	perl(warnings)
# =============== Test Suite ===================
BuildRequires:	perl(base)
BuildRequires:	perl(lib)
BuildRequires:	perl(Test::More) >= 0.88
# =============== Dependencies =================
%if 0%{?fedora} < 38 && 0%{?rhel} < 10
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
%endif
Requires:	perl(Scalar::Util) >= 1.20
Requires:	perl(Sub::Identify) >= 0.03

%description
When subclassing a class, you occasionally want to dispatch control to the
superclass - at least conditionally and temporarily. This module provides
an easier, cleaner way for class methods to access their ancestor's
implementation.

%prep
%setup -q -n SUPER-%{version}

%build
perl Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}

%install
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -delete
%{_fixperms} -c %{buildroot}

%check
make test

%files
%license LICENSE
%doc Changes README
%{perl_vendorlib}/SUPER.pm
%{_mandir}/man3/SUPER.3*

%changelog
* Thu May  4 2023 Paul Howarth <paul@city-fan.org> - 1.20190531-14
- Use SPDX-format license tag
- Use %%license unconditionally

* Mon Jun  3 2019 Paul Howarth <paul@city-fan.org> - 1.20190531-1
- Update to 1.20190531
  - Allow main->SUPER::... to work when SUPER.pm is loaded (GH#1)
- Switch upstream from search.cpan.org to metacpan.org

* Thu Apr 12 2018 Paul Howarth <paul@city-fan.org> - 1.20141117-10
- BR: perl-generators unconditionally
- BR: perl-interpreter rather than perl
- Drop support for EOL distributions prior to F-13
  - Drop BuildRoot: and Group: tags
  - Drop explicit buildroot cleaning in %%install section
  - Drop explicit %%clean section
  - Drop workaround for building with Test::More < 0.88

* Tue Sep 27 2016 Paul Howarth <paul@city-fan.org> - 1.20141117-6
- BR: perl-generators where available
- Package LICENSE file
- Simplify find command using -delete

* Mon Nov 17 2014 Paul Howarth <paul@city-fan.org> - 1.20141117-1
- Update to 1.20141117
  - Improved export mechanism
  - Removed useless Exporter tests
  - Improved docs (CPAN RT#79681)
- Add patch to support building with Test::More < 0.88

* Mon Nov 17 2014 Paul Howarth <paul@city-fan.org> - 1.20141116-1
- Update to 1.20141116
  - Resolved Test::More changes (CPAN RT#97939)
- Switch to ExtUtils::MakeMaker flow

* Fri Aug 29 2014 Paul Howarth <paul@city-fan.org> - 1.20120705-7
- Perl 5.20 rebuild

* Fri Jul  6 2012 Paul Howarth <paul@city-fan.org> - 1.20120705-1
- Update to 1.20120705
  - Resolved PAUSE packaging nit (CPAN RT#77110)
  - Converted to dzil
- Drop provides filter, not needed due to fix for CPAN RT#77110
- Classify buildreqs by what they are required for
- BR: perl(Test::Builder::Module) rather than perl(Test::Simple) ≥ 0.61

* Mon Jun 25 2012 Paul Howarth <paul@city-fan.org> - 1.17-8
- BR: perl(base), perl(lib) and perl(Test::More)

* Tue Mar  6 2012 Paul Howarth <paul@city-fan.org> - 1.17-7
- BR: perl(Carp) and perl(Exporter)
- Drop explicit requires of perl(Exporter) since it's auto-detected by rpm
  4.9 onwards, and is bundled with perl on all older distributions
- Don't need to remove empty directories from buildroot
- Drop compatibility with distributions prior to FC-5 since we need
  Test::Simple ≥ 0.61:
  - %%defattr redundant since rpm 4.4
  - Don't need to run test suite with LC_ALL=C
  - Don't need to define %%{perl_vendorlib}

* Sat Jul  2 2011 Paul Howarth <paul@city-fan.org> - 1.17-5
- Rebuild for perl 5.14.1 in Rawhide
- Use %%{_fixperms} rather than our own %%{__chmod} incantation
- Add rpm-4.9 compatible provides filter
- Nobody else likes macros for commands
- Fix dist tag for CentOS 6 and Scientific Linux

* Fri Jun 25 2010 Paul Howarth <paul@city-fan.org> - 1.17-4
- Rebuild for perl 5.12.1 in Rawhide

* Mon May 17 2010 Paul Howarth <paul@city-fan.org> - 1.17-3
- Fix dist tag for RHEL-6 Beta

* Fri Nov 27 2009 Paul Howarth <paul@city-fan.org> - 1.17-2
- Import from Fedora
- Drop version requirement on Scalar::Util - it'll pass test suite with older
  versions, and the limiting factor on backwards compatibility is Test::Simple

* Sun Sep 27 2009 Chris Weyl <cweyl@alumni.drew.edu> - 1.17-1
- Update filtering
- Auto-update to 1.17 (by cpan-spec-update 0.01)
- Added a new br on perl(Scalar::Util) (version 1.20)
- Altered br on perl(Sub::Identify) (0 => 0.03)
- Altered br on perl(Test::Simple) (0 => 0.61)
- Added a new req on perl(Scalar::Util) (version 1.20)
- Added a new req on perl(Sub::Identify) (version 0.03)

* Sun Jul 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.16-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Thu Feb 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.16-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Tue Mar 04 2008 Tom "spot" Callaway <tcallawa@redhat.com> - 1.16-3
- Rebuild for new perl

* Wed Jan 02 2008 Ralf Corsépius <rc040203@freenet.de> - 1.16-2
- Adjust License-tag
- BR: perl(Test::Simple) (BZ 419631)

* Wed Apr 04 2007 Chris Weyl <cweyl@alumni.drew.edu> - 1.16-1
- Update to 1.16

* Tue Oct 03 2006 Chris Weyl <cweyl@alumni.drew.edu> - 1.15-1
- Update to 1.15
- Add explict requires on perl(Exporter); missed due to a use base construct

* Thu Sep 07 2006 Chris Weyl <cweyl@alumni.drew.edu> - 1.14-4
- Bump

* Thu Sep 07 2006 Chris Weyl <cweyl@alumni.drew.edu> - 1.14-3
- Update %%description and %%summary

* Thu Sep 07 2006 Chris Weyl <cweyl@alumni.drew.edu> - 1.14-2
- Filter errant perl(DB) provide

* Tue Sep 05 2006 Chris Weyl <cweyl@alumni.drew.edu> - 1.14-1
- Specfile autogenerated by cpanspec 1.69.1
